## sather-1.3-beta-7.tar.bz2

=== Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

###############################################################################
# Be sure to read the file Doc/Installation!
# You may need to set some variables in System/Common/CONFIG.proto
# to be appropriate to your system.
# Also make sure to adjust the paths in System/Platforms/X/Platform.module
# and System/Platforms/tcltk/Platform.module
###############################################################################

export SATHER_HOME=$(shell pwd)
export LOCALE=en_NZ
export SATHER_ENV=$(SATHER_HOME)/resources/$(LOCALE)/bin/LIBCHARS
unexport SATHER_LIBRARY

###############################################################################
# include configuration information

include $(SATHER_HOME)/config.default

##############################################################################
# construct the needed variables

SACOMP          =bin/sacomp
SACOMP_BOOT     =bin/sacomp-boot
SACOMP_BOOT_CODE=bin/sacomp-boot.code
SACOMP_DEBUG    =bin/sacomp-debug
SACOMP_PROFILE  =bin/sacomp-profile
SABROWSE        =bin/sabrowse

CS_OPT        =-verbose -O_fast -O_no_move_while -O_no_hoist_const -O_no_cse -only_reachable -pretty
CS_OPT_DEBUG  =-verbose -chk -debug -debug_deterministic -debug_no_backtrace
CS_OPT_PROFILE=-verbose -only_reachable -optimize -C_flag -pg

################################ DEPENDENCIES #################################

# The compiler which ends up in bin/ is the "fast" executable,
# which means that checking is turned off and optimizations are on.

# Some makes can't expand glob syntax with more than one *, so
# only specify one directory to expand instead of listing all of them.
# Watch out for this if you are modifying the compiler.

# This runs the C compiles after the Sather compiler instead of at
# the same time, to ease installation for those with small VM.

default: $(SACOMP)

$(SACOMP): $(SACOMP_BOOT)
	@echo "**** Creating C for installation compiler *****"
#	$(SACOMP_BOOT) $(CS_OPT) sacomp/sacomp.module -o $(SACOMP) -only_C
# Ugly, but the clean solution in sacomp means some work...:
	cp platforms/cygwin/Platform.empty platforms/cygwin/Platform.module
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT) ../sacomp/sacomp.module -o ../$(SACOMP) -only_C
	@echo "***** Compiling C for installation compiler *****"
	$(MAKE) -C $(SACOMP).code
	cp platforms/cygwin/Platform.run platforms/cygwin/Platform.module
# CFLAGS="-I. -g"

boot: $(SACOMP_BOOT)

optional: browser gui-server

browser: $(SACOMP_BOOT)
	@echo "***** Creating C for Browser *****"
	$(SACOMP_BOOT) $(CS_OPT) auxiliaries/sabrowse/sabrowse.module -o $(SABROWSE) -only_C
	@echo "***** Compiling C for Browser *****"
	$(MAKE) -C $(SABROWSE).code

gui-server: $(SACOMP)
	$(MAKE) -C auxiliary/sagui-server

debug: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT_DEBUG) ../sacomp/sacomp.module -o $(SACOMP_DEBUG) -only_C
	$(MAKE) -C $(SACOMP_DEBUG).code

profile: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP) $(CS_OPT_PROFILE) ../sacomp/sacomp.module -o $(SACOMP_PROFILE) -only_C
	$(MAKE) -C $(SACOMP_PROFILE).code

$(SACOMP_BOOT): system
	@echo; echo "Making boot compiler..." ; echo
	$(LN) ../$(BOOT_PLATFORM)/header.h platforms/BOOT/header.h
	$(MAKE) -C $(SACOMP_BOOT_CODE) $(MAKE_OPT_BOOT)

# The rule for System/Common/CONFIG also makes the serial libraries,
# as well as making any platforms.

system:
	for i in $(SATHER_HOME)/resources/*/bin ; do \
	  $(RM) $$i/LIBCHARS ;                          \
	  $(LN) $(LIBCHARS_VERSION) $$i/LIBCHARS ;   \
	done

	$(MAKE) -C system

	for i in `echo "BOOT",$(PLATFORMS) | tr , \ `; do		\
	  echo "Making platform $$i..." ;				\
	  $(MAKE) -C platforms/$$i ;					\
	done


info:
	cd emacs && makeinfo sather.texinfo
	cd emacs && makeinfo sather-tutorial.texinfo
	cd emacs && makeinfo sather-mode.texinfo

.PHONY: boot optional browser gui-server debug profile system info \
test clean-unneeded clean info

################################### TESTING ###################################

test:
	$(MAKE) -C test

################################### CLEANING ##################################

clean:
	$(MAKE) -C system clean
	$(MAKE) -C test clean
	$(MAKE) -C auxiliaries/sagui-server clean

	for i in platforms/* ; do					\
	  if [ -f $$i/Makefile ] ; then $(MAKE) -C $$i clean ; fi	\
	done;

	$(RM) -r $(SACOMP).code $(SABROWSE).code
	$(RM) -r $(SACOMP_PROFILE).code $(SACOMP_DEBUG).code
	$(RM) $(SACOMP_BOOT).code/*.o
	$(RM) $(SACOMP) $(SACOMP_BOOT) $(SABROWSE)
	$(RM) $(SACOMP_PROFILE) $(SACOMP_DEBUG)

	$(RM) $(SATHER_HOME)/resources/*/bin/LIBCHARS

	$(RM) config.platform

	$(RM) emacs/*.elc
	$(RM) emacs/*.info emacs/*.info??

	[ -x debian/rules ] && debian/rules clean-safe

=== system/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SATHER_HOME=$(shell cd ..;pwd)

include $(SATHER_HOME)/config.default

LIBRARY=../lib
LIBRARY_BOOT=../lib-boot
##########PLIBRARY_BOOT=../lib-boot-psather

default: CONFIG CONFIG-boot

TMPFILE=CONFIG.tmp.c

CONFIG: CONFIG.proto \
	$(LIBRARY)/*.config \
	$(LIBRARY)/Required/*.config \
	$(LIBRARY)/Required/*/config/* \
	$(LIBRARY)/Maths/config/* \
	$(LIBRARY)/External/config/*

CONFIG-boot: CONFIG-boot.proto \
	     $(LIBRARY_BOOT)/*.config \
	     $(LIBRARY_BOOT)/*/*.config
########	     $(PLIBRARY_BOOT)/*/*.config

CONFIG CONFIG-boot: Makefile ../Makefile ../config.platform
	@echo Creating system/$@...
	@echo "-- This file has been created by using cpp on $@.proto" > $(TMPFILE)
	@echo "-- in this directory and by using variables defined " >> $(TMPFILE)
	@echo "-- in the top level Makefile. Please do not edit it" >> $(TMPFILE)
	@echo "#define CONFIG_DEFAULT_PLATFORM \"$(DEFAULT_PLATFORM)\"" >> $(TMPFILE)
	@echo -n "#define CONFIG_PLATFORMS \"" >> $(TMPFILE)
	@echo -n                           $(PLATFORMS) | sed "s/ //g;s/,/\",\"/g" >> $(TMPFILE)
	@echo                                                                    "\"" >> $(TMPFILE)
	@echo "#define CONFIG_VERSION \"$(VERSION)\"" >> $(TMPFILE)
	@echo "#include \"$@.proto\"" >> $(TMPFILE)
	@$(CPP) -P -undef $(TMPFILE) > $@
	@$(RM) $(TMPFILE)

# The following did not work, because of predefined macros. Unfortunately, I could not find a way to
# remove predefined macros while still keep the macros defined at the command line
#	@$(CPP) -Uunix -DCONFIG_DEFAULT_PLATFORM='$(DEFAULT_PLATFORM)' -DCONFIG_PLATFORMS='$(PLATFORMS)' CONFIG.proto >> CONFIG

clean:
	$(RM) CONFIG CONFIG-boot $(TMPFILE)
	$(RM) -r lib include
	$(MAKE) clean -C activethreads
#	$(MAKE) clean -C am
	$(MAKE) clean -C brahma
	$(MAKE) clean -C lwp
	$(MAKE) clean -C psather
	$(MAKE) clean -C siva

=== test-boot/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SACOMP         =bin/sacomp-boot
CS_OPT         =-chk -verbose -output_C
CS_PSATHER_OPT =-linux/lwp

TESTCS1     =./test-cs-first
TESTCS2     =./test-cs-second
TESTALL     =./test-all
TESTFULL    =./test-full
TESTPSATHER =./test-psather

####################### TESTING ########################

test: test-all

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full 
# double compilation of the compiler, which can take quite a while.

test-all:
	@echo; echo Testing...; echo
	../$(SACOMP) $(CS_OPT) test-all.module -main TEST_OBLIG -o $(TESTALL)
	$(TESTALL) > $(TESTALL).output

# The full test does the following:
#
#    1. Compile using Bin/sacomp, with full checking on.
#    2. Compile using result.
#    3. Clean up.

test-full:
	@echo; echo "Doing full test..." ; echo
	@echo; echo "Compiling 1st..." ; echo
	../$(SACOMP) $(CS_OPT) ../Compiler/sacomp.module -o $(TESTCS1)
	@echo; echo "Compiling 2nd..." ; echo
	$(TESTCS1) $(CS_OPT) ../Compiler/sacomp.module -o $(TESTCS2)
	
	$(TESTCS2) $(CS_OPT) test-all.module -o $(TESTFULL)
	$(TESTFULL) > $(TESTFULL).output
	
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in `echo $(PLATFORMS) | tr , \ ` ; do		\
	  echo "Testing platform $$i..." ;			\
	  $(MAKE) -C ../System/Platforms/$$i test ;		\
	done
	
	@echo; echo "Everything okay" ; echo

test-psather:
	../$(SACOMP) $(CS_OPT) $(CS_PSATHER_OPT) test-psather.module -o $(TESTPSATHER)
	$(TESTPSATHER) > $(TESTPSATHER).output

clean:
	rm -fr $(TESTCS1) $(TESTCS1).code
	rm -fr $(TESTCS2) $(TESTCS2).code
	rm -fr $(TESTALL) $(TESTALL).code $(TESTALL).output
	rm -fr $(TESTFULL) $(TESTFULL).code $(TESTFULL).output
	rm -fr $(TESTPSATHER) $(TESTPSATHER).code $(TESTPSATHER).output

# These test rules are used at the ICSI. If you work on the compiler they
# may be useful for you too, but you will probably have to hack the perl
# scripts in Test and Test/TestPrg/PROG (they are adapted to the 
# specific way files and home directories are set up at ICSI).

testcommit: SYSTEM prepare_test 
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in solaris					\
	         solaris/sparc_smp				\
		 solaris/sparc_tcpip				\
	         solaris_at/sparc_smp				\
		 solaris_at/sparc_myrinet; do			\
	  echo "Making platform $$i..." ;			\
	  $(MAKE) -C System/Platforms/$$i			\
	done
	
	./do_test solaris solaris/sparc_smp solaris/sparc_tcpip \
	          solaris_at/sparc_smp solaris_at/sparc_myrinet

testcomplete:
	./do_test `echo $(PLATFORMS) | tr '",' '  '`

testplatform:
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	$(MAKE) -C ../System/Platforms/$(PLATFORM)
	./do_test `echo $(PLATFORM)`

=== test/Makefile ===
export SATHER_HOME=$(shell cd ..;pwd)
export LOCALE=en_NZ
export SATHER_ENV=$(SATHER_HOME)/resources/$(LOCALE)/bin/LIBCHARS

#CS_OPT=-chk -verbose -only_reachable -pretty -debug
CS_OPT=-chk -debug -verbose -pretty
CS_OPT_CONC=-chk -debug -verbose -pretty -linux/smp
SACOMP=$(SATHER_HOME)/bin/sacomp

default: do_test do_std_chans do_all

do_%: test_%
	./test_$(*) 2>&1 | tee test_$(*).output

test_test: FORCE
	$(SACOMP) test.module -o test_test -main TEST_TEST $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_test.code

test_std_chans: FORCE
	$(SACOMP) test.module -o test_std_chans -main TEST_STD_CHANS $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_std_chans.code

test_all: FORCE
	$(SACOMP) test.module -o test_all -main TEST_ALL $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_all.code

test_conc: FORCE
	$(SACOMP) test.module -o test_conc -main TEST_LL_LOCK $(CS_OPT_CONC) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_conc.code

test_minimal: FORCE
	$(SACOMP) test.module -o test_minimal -main TEST_MINIMAL $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_minimal.code

FORCE:

clean:
	rm -rf test_test.code test_std_chans.code
	rm -rf test_conc.code test_all.code test_minimal.code
	rm -f test_test test_std_chans test_all test_minimal
	rm -f *.output

=== auxiliaries/sagui-server/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

default: all

# Generate the server end for the dual process gui
export SATHER_HOME=$(shell cd ../..;pwd)
include $(SATHER_HOME)/config.default

CS_OPT=-verbose -only_reachable -pretty -chk
SACOMP=$(SATHER_HOME)/bin/sacomp

SAGUI_SERVER=$(SATHER_HOME)/bin/sagui-server

all: $(SAGUI_SERVER)

$(SAGUI_SERVER):
	$(SACOMP) sagui-server.module -o $(SAGUI_SERVER) $(CS_OPT) -only_C
	$(MAKE) -C $(SAGUI_SERVER).code

clean:
	$(RM) -R $(SAGUI_SERVER) $(SAGUI_SERVER).code

=== auxiliaries/salccomp/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 2000 by Free Software Foundation, Inc.                      -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

export SATHER_HOME=$(shell cd ../..;pwd)

CS_OPT=-verbose -only_reachable -pretty -chk
SACOMP=$(SATHER_HOME)/bin/sacomp

LCCOMP         =$(SATHER_HOME)/bin/salccomp
LCCOMP_DEF_DIR =$(SATHER_HOME)/resources/lcc-Data/definitions

salccomp: FORCE
	$(SACOMP) salccomp.module -o $(LCCOMP) -main BUILDER $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C $(LCCOMP).code

FORCE:

# make the boot cultural definitions
iso8859_1:
	cd $(LCCOMP_DEF_DIR); $(LCCOMP) -code ISO8859-1 -config local-win32

# make the default cultural definitions
default:
	cd $(LCCOMP_DEF_DIR); $(LCCOMP) -code UCS2 -config default-win32

=== bin/sacomp-boot.code/Makefile ===
SHOME  =../..
CFLAGS = -I.  -O  -I../system
CC     =gcc
HDR    =sather.h tags.h
LIBS   = -lgc -lm
CS     =sacomp-boot
OBJ    = a_stackA_STACK2014955575.o am_outAM_OUT1363671444.o am_outAM_OUT1363671444x.o arefFSETAM_ROU1518004496.o arefFSETIMMUTA2116029667.o arefFSETTUPSIG268064465.o arrayARRAYAM_I1084914261.o arrayARRAYTUPI1927875024.o as_outAS_OUT1429002792.o as_outAS_OUT1429002792x.o cgenCGEN1354269066.o cgenCGEN1354269066x.o cgenCGEN1354269066xx.o cgenCGEN1354269066xxx.o cgenCGEN1354269066xxxx.o cgenCGEN1354269066xxxxx.o cgenCGEN1354269066xxxxxx.o cgenCGEN1354269066xxxxxxx.o cgenCGEN1354269066xxxxxxxx.o cgenCGEN1354269066xxxxxxxxx.o cgenCGEN1354269066xxxxxxxxxx.o code_fileCODE_372141741.o configCONFIG_R422014871.o constAM_VOID_C1458622435.o cs_optionsCS_O301318552.o cs_optionsCS_O301318552x.o cursorAM_CURSO1314676474.o cursorAM_CURSO1314676474x.o cursorAM_CURSO1314676474xx.o cursorAM_CURSO1314676474xxx.o dispatch.o eltELT742463773.o elt_algELT_ALG1548486913.o elt_algELT_ALG241706736.o elt_algELT_ALG433952755.o elt_algELT_ALG656599769.o elt_algELT_ALG987448979.o flistFLISTAM_C1171004157.o flistFLISTTUPA253333040.o fmapFMAPAM_ROU1000508936.o fmapFMAPSTRFSE258056667.o fmapFMAPdTPCOD1051074108.o generate_amGEN60284023.o get_optionsCOD183550016.o globals.o get_optionsCOD183550016x.o implIMPL_CREAT99472218.o inlineINLINE_I1557365391.o intiINTI1462257232.o layoutCLASS_LA1330944056.o mangleMANGLE1705139666.o mangleNAMESPAC760510184.o o_localOPT_LOC907909712.o o_localOPT_LOC907909712x.o optimizeOPT_CO1177876774.o optimizeOPT_IT1193060919.o parsePARSER311504339.o parsePARSER311504339x.o parsePARSER311504339xx.o parsePARSER311504339xxx.o parsePARSER311504339xxxx.o progPROG_AS_TB824135997.o scanSCANNER1990933774.o side_effectSE_411721069.o strings.o stringsx.o stringsxx.o system.o stmtAM_FORK_ST1674905658.o tpTP_BUILTIN1142074570.o tpTP_ITER145455607.o transTRANS2123847391.o transTRANS2123847391x.o transTRANS2123847391xx.o transTRANS2123847391xxx.o transTRANS2123847391xxxx.o tupTUPAM_CURSO1313579705.o unbox.o unixUNIX1766692.o runtime.o
OTHER  =


../$(CS): LINK_OPTIONS $(OBJ) $(HDR)
	$(CC) $(CFLAGS) -o ../$(CS) $(OBJ) $(OTHER) $(LIBS)

$(OBJ): COMPILE_OPTIONS $(HDR)

runtime.o: ../../system/old-runtime/runtime.c COMPILE_OPTIONS $(HDR)
	$(CC) $(CFLAGS) -c ../../system/old-runtime/runtime.c

=== system/activethreads/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SATHER_HOME=$(shell cd ../..;pwd)

include $(SATHER_HOME)/config.default

ARCHITECTURES=sparc_solaris \
	      i386_solaris \
	      i386_linux \
	      i386_cygwin \
	      hppa_hpux \
	      axp_osf \
	      mips_irix5

default: beware
	$(MAKE) -C src ARCH=$(ARCH)
	$(MAKE) -C schedulers ARCH=$(ARCH)

install: beware
	[ -d ../lib ] || mkdir ../lib
	[ -d ../include ] || mkdir ../include
	$(MAKE) -C src install ARCH=$(ARCH)
	$(MAKE) -C schedulers install ARCH=$(ARCH)

tests: beware all
	$(MAKE) -C tests ARCH=$(ARCH)

clean:
	$(MAKE) -C src clean
	$(MAKE) -C schedulers clean
	$(MAKE) -C tests clean
	$(MAKE) -C ConjunctiveLocks clean

beware:
ifndef ARCH
	@echo ERROR: Variable ARCH has to be specified
	@exit 1
endif

=== system/brahma/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Platforms:
#
#  cygwin_smp_at
#  cygwin_tcp
#  hpux_hppa_smp_at
#  linux_smp_at		- pthread implementation
#  linux_lwp		- LWP-Thread simulation (non-preemptive)
#  osf_axp_smp_at
#  serial		- No concurrency
#  solaris_smp_at	- Threads, emulated clusters (Active Threads based)
#  solaris_smp		- Threads, emulated clusters (solaris)
#  solaris_tcp		- TCP/IP AM (solaris)

#  solaris_myrinet
#  solaris_myrinet_at

###################################

SATHER_HOME=$(shell cd ../..;pwd)

include $(SATHER_HOME)/config.default

ARCHITECTURES = cygwin_smp_at \
	        cygwin_tcp \
		hpux_hppa_smp_at \
		linux_smp_at \
		linux_lwp \
		osf_axp_smp_at \
		serial \
		solaris_smp_at \
		solaris_smp \
		solaris_tcp

HEADER = at_sync.h \
	 at_types.h \
	 brahma.h \
	 brahma2am.h \
	 solaris_sync.h \
	 solaris_types.h \
	 tcpam.h


###################################

default: beware brahma_$(ARCH).o

beware:
ifndef ARCH
	@echo ERROR: Variable ARCH has to be specified
	@exit 1
endif

install: beware brahma_$(ARCH).o
	[ -d ../lib ] || mkdir ../lib
	[ -d ../include ] || mkdir ../include
	cp -f $(HEADER) ../include
	cp -f brahma_$(ARCH).o ../lib
	cp -f arch_$(ARCH).h ../include

##################################

$(patsubst %,brahma_%.o,$(ARCHITECTURES)): brahma_%.o: arch_%.c arch_%.h brahma.h

brahma_solaris_smp.o \
brahma_solaris_tcp.o: solaris_sync.c solaris_sync.h

brahma_cygwin_tcp.o \
brahma_solaris_tcp.o: brahma2am.h barrier.c

brahma_cygwin_smp_at.o \
brahma_hpux_hppa_smp_at.o \
brahma_linux_smp_at.o \
brahma_osf_axp_smp_at.o \
brahma_solaris_smp_at.o: at_types.h at_sync.h at_sync.c

##################################

brahma_cygwin_tcp.o \
brahma_serial.o \
brahma_solaris_smp.o \
brahma_solaris_tcp.o \
brahma_linux_lwp.o \
brahma_cygwin_smp_at.o \
brahma_hpux_hppa_smp_at.o \
brahma_linux_smp_at.o \
brahma_osf_axp_smp_at.o \
brahma_solaris_smp_at.o:
	$(CC) $(CFLAGS) -I../include -c $< -o $@

#brahma_solaris_myrinet.a: FORCE
#	$(MAKE) -C arch_solaris_myrinet solaris_sparc INSTALL=brahma_solaris_myrinet.a \
#	        THREAD_FLAGS="-DBRAHMA_solaris_myrinet -DSOLARIS -DSOLARIS_THREADS -D_REENTRANT"

#brahma_solaris_myrinet_at.a: FORCE
#	$(MAKE) -C arch_solaris_myrinet_at solaris_smp_at \
#	        INSTALL=brahma_solaris_myrinet.a \
#		THREAD_FLAGS="-O4 -DSOLARIS -DAT_THREADS -DBRAHMA_solaris_myrinet_at -I../$(AT_INCLUDE_DIR)"

#FORCE:

###################################

clean:
	rm -f *.a *.o
#	$(MAKE) -C arch_solaris_myrinet/src clean

#####################################

# Don't use -O3 to avoid interprocedual opts...
benchmark_smp: solaris_smp.a $(BENCHMARK_DIR)/benchmark.c
	gcc -O2 -DBR_SOLARIS_SMP -I. $(BENCHMARK_DIR)/benchmark.c lib/solaris_smp.a -o benchmark_smp

# Don't use -O3 to avoid interprocedual opts...
benchmark_solaris_smp_at: solaris_smp_at.a $(BENCHMARK_DIR)/benchmark.c
	gcc $(DEBUG_FLAG) -g -DBR_SOLARIS_SMP_AT $(SMP_AT_INC_DIR) $(BENCHMARK_DIR)/benchmark.c lib/solaris_smp_at.a -o benchmark_solaris_smp_at $(AT_LIB_DIR) $(AT_LIBS)

benchmark_tcp: solaris_tcp.a $(BENCHMARK_DIR)/benchmark.c
	gcc -O2 -DBR_SOLARIS_TCP -I. $(BENCHMARK_DIR)/benchmark.c solaris_tcp.a -o lib/benchmark_tcp

benchmark_myrinet: solaris_myrinet.a $(BENCHMARK_DIR)/benchmark.c
	gcc $(MYRI_FLAGS) -DSOLARIS_THREADS -DBR_MYRINET_SOLARIS $(MYRI_INC_DIRS) -I$(COMMON_DIR) $(BENCHMARK_DIR)/benchmark.c -o benchmark_myrinet $(MYRI_LIB_DIRS) lib/solaris_myrinet.a $(MYRI_LIBS)

benchmark_sparc_myrinet_at: solaris_sparc_myrinet_at.a $(BENCHMARK_DIR)/benchmark.c
	gcc -g -DAT_NO_INLINE -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) $(BENCHMARK_DIR)/benchmark.c -o benchmark_at_sparc_myrinet $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat -lposix4

###################################

test_threads_at: myrinet_solaris/tests/test_threads.c
	gcc -O $(DEBUG_FLAG) -DDEBUG -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_threads.c -o test_threads_at  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat -lposix4

test_threads: myrinet_solaris/tests/test_threads.c
	gcc -O $(DEBUG_FLAG) -DDEBUG -DSOLARIS_THREADS -DBR_MYRINET_SOLARIS $(MYRI_INC_DIRS) myrinet_solaris/tests/test_threads.c -o test_threads  $(MYRI_LIB_DIRS) lib/solaris_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS)

test_short_at: myrinet_solaris/tests/test_short.c
	gcc -O $(DEBUG_FLAG) -DDEBUG -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_short.c -o test_short_at  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat

test_migration: myrinet_solaris/tests/test_migration.c myrinet_solaris/src/migration.c
	gcc $(DEBUG_FLAG) -g -DAT_NO_INLINE -DDEBUG -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_migration.c myrinet_solaris/src/migration.c -o test_migration  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat
#	gcc $(DEBUG_FLAG) -O4 -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_migration.c myrinet_solaris/src/migration.c -o test_migration  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat

qsort: myrinet_solaris/tests/qsort.c myrinet_solaris/src/migration.c
#	gcc $(DEBUG_FLAG) -g -O -DAT_NO_INLINE -DDEBUG -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/qsort.c myrinet_solaris/src/migration.c -o qsort  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat
	gcc $(DEBUG_FLAG) -O4 -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/qsort.c myrinet_solaris/src/migration.c -o qsort  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat

test_store: myrinet_solaris/tests/test_store.c
	gcc -O4 $(DEBUG_FLAG) -DAT_THREADS -DBR_MYRINET_SOLARIS_AT $(MYRI_INC_DIRS) $(AT_COMMON_INC_DIR) myrinet_solaris/tests/test_store.c myrinet_solaris/src/migration.c  -o test_store  $(MYRI_LIB_DIRS) lib/solaris_at_sparc_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS) -lkstat

test_short: myrinet_solaris/tests/test_short.c
	gcc -O $(DEBUG_FLAG) -DDEBUG -DSOLARIS_THREADS -DBR_MYRINET_SOLARIS $(MYRI_INC_DIRS) myrinet_solaris/tests/test_short.c -o test_short  $(MYRI_LIB_DIRS) lib/solaris_myrinet.a $(MYRI_LIBS) $(AT_LIB_DIR) $(AT_LIBS)

###################################

t1:	t1.c brahma.h solaris_tcp.a
	gcc $(DEBUG_FLAG) -c -DBR_SOLARIS_TCP t1.c
	gcc $(DEBUG_FLAG) t1.o solaris_tcp.a -o t1

t2:	t2.c br_barrier.c brahma.h solaris_tcp.a
	gcc -c -DBR_SOLARIS_TCP t2.c
	gcc $(DEBUG_FLAG) br_barrier.o t2.o solaris_tcp.a -o t2

###################################

btest: solaris_smp.a $(TEST_DIR)/btest.c
	gcc -O2 -DBR_SOLARIS_SMP -I. $(TEST_DIR)/btest.c solaris_smp.a -o btest

###################################

debug:
	gmake solaris_sparc_myrinet_at.a
	gmake test_migration ARCH=sparc-solaris

=== platforms/cygwin/smp_at/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:
	@ echo Making Active Threads library for Brahma
	$(MAKE) -C ../../../system/activethreads install ARCH=cygwin_smp_at
	@ echo Making Brahma cygwin smp at lwp library
	$(MAKE) -C ../../../system/brahma install ARCH=cygwin_smp_at

clean:
test:

=== platforms/osf/smp_axp/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all: 
	@ echo Making Active Threads library for Brahma
	$(MAKE) -C ../../../system/activethreads axp-osf
	@ echo Making Brahma osf_at_axp_smp library
	$(MAKE) -C ../../../system/brahma osf_at_axp_smp  INSTALL=lib/osf_at_axp_smp.a ARCH=axp-osf

clean:

test:

=== platforms/solaris/i386_smp_at/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all: 
	@ echo Making Active Threads library for Brahma
	$(MAKE) -C ../../../system/activethreads i386-solaris
	@ echo Making Brahma at_solaris_smp library
	$(MAKE) -C ../../../system/brahma at_solaris_smp INSTALL=lib/at_solaris_smp.a ARCH=i386-solaris

clean:
test:

=== debian/control ===
Source: sather
Section: devel
Priority: optional
Maintainer: Norbert Nemec <nobbi@gnu.org>
Standards-Version: 2.4.0.0

Package: sather
Architecture: any
Depends: libgc-dev, ${shlibs:Depends}
Suggests: tk8.0-dev
Description: Sather compiler
 Compiler and programming environment for Sather:
 Sather is an object oriented language which designed to be simple,
 efficient, safe, and non-proprietary. It aims to meet the needs of
 modern research groups and to foster the development of a large,
 freely available, high-quality library of efficient well-written
 classes for a wide variety of computational tasks. It was originally
 based on Eiffel but now incorporates ideas and approaches from several
 languages. One way of placing it in the "space of languages" is to say
 that it attempts to be as efficient as C, C++, or Fortran, as elegant
 and safe as Eiffel or CLU, and to support higher-order functions as
 well as Common Lisp, Scheme, or Smalltalk.

Package: sather-lwp
Architecture: any
Depends: sather
Description: pSather - Parallel extensions to the Sather environment
 This is based on LWP, a implementation of user-space threads, which is also
 included in this package.

Package: sather-doc
Architecture: all
Suggests: sather, www-browser, postscript-viewer, info-browser
Description: Documentation for the object oriented language Sather
 HTML, PostScript, Info documentation for the object oriented language
 Sather.

Package: sather-elisp
Architecture: all
Depends: emacsen
Suggests: sather
Description: Emacs mode for editing Sather programs
 Emacs mode for editing Sather programs.

Package: sather-browser
Architecture: any
Depends: sather, c-shell, tclsh, ${shlibs:Depends}
Description: A Tcl/Tk based class browser for Sather.
 A class browser for the OO-language Sather, written in Sather, using the 
 Tcl/Tk toolkit.
